unit Sdimain;

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls, Gauges, MPlayer;

type
  TSDIAppForm = class(TForm)
    SDIAppMenu: TMainMenu;
    FileMenu: TMenuItem;
    OpenItem: TMenuItem;
    SaveItem: TMenuItem;
    ExitItem: TMenuItem;
    N1: TMenuItem;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    Help1: TMenuItem;
    About1: TMenuItem;
    SpeedPanel: TPanel;
    OpenBtn: TSpeedButton;
    SaveBtn: TSpeedButton;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    Panel9: TPanel;
    Panel10: TPanel;
    Panel11: TPanel;
    Gauge1: TGauge;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Timer1: TTimer;
    Timer2: TTimer;
    SpeedButton1: TSpeedButton;
    Timer3: TTimer;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Image1: TImage;
    Roll: TMenuItem;
    RollNew: TMenuItem;
    RollClear: TMenuItem;
    RollShow: TMenuItem;
    Image2: TImage;
    SpeedButton4: TSpeedButton;
    Label2: TLabel;
    Label1: TLabel;
    MediaPlayer1: TMediaPlayer;
    procedure ShowHint(Sender: TObject);
    procedure ExitItemClick(Sender: TObject);
    procedure OpenItemClick(Sender: TObject);
    procedure SaveItemClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FileRead(Name: String);
    procedure FileWrite(Name: String);
    procedure Roulette;
    procedure BitBtn1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Str: array [0..120] of String;
    FName: String; //  
    mfPath  : String;  //  
    Nmr : integer; //  
    NPrize: integer; //  (  array Str)
    T2N : integer;
  end;

var
  SDIAppForm: TSDIAppForm;

implementation

uses SysUtils, About;

{$R *.DFM}

procedure TSDIAppForm.ShowHint(Sender: TObject);
begin
//  StatusBar.SimpleText := Application.Hint;
end;

procedure TSDIAppForm.ExitItemClick(Sender: TObject);
begin
  Close;
end;

procedure TSDIAppForm.OpenItemClick(Sender: TObject);
begin
  OpenDialog.Execute
end;

procedure TSDIAppForm.SaveItemClick(Sender: TObject);
begin
  SaveDialog.Execute;
end;

procedure TSDIAppForm.About1Click(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TSDIAppForm.FormCreate(Sender: TObject);
begin
  Application.OnHint := ShowHint;
end;

procedure TSDIAppForm.FormActivate(Sender: TObject);
begin
  Image1.Picture.LoadFromFile('Picture1.bmp');
  Image2.Picture.LoadFromFile('Picture2.bmp');
  Panel3.Caption := '';
  Panel4.Caption := '';
  Panel5.Caption := '';
  Panel6.Caption := '';
  Panel7.Caption := '';
  Panel8.Caption := '';
  Panel9.Caption := '';
  Panel10.Caption := '';
  Panel11.Caption := '';
  //
  BitBtn1.SetFocus;
  //
  FName := '1.txt';
              //   
              mfPath := ExpandFileName(FName);
              mfPath := ExtractFilePath(mfPath);
  FileRead(mfPath + FName);
  FileWrite('2.txt');
  FileRead( '2.txt');
  //
  MediaPlayer1.Close;
  MediaPlayer1.FileName := 'sound1.wav';
  MediaPlayer1.Open;
  MediaPlayer1.Play;
  //
end;

procedure TSDIAppForm.FileRead(Name: String);
var
  F1: TextFile;
  NewCod: String;
  N : integer;
begin
  AssignFile(F1, Name);
  {$I-}
  Reset(F1);
  {$I+}
  if IOResult <> 0 then
  begin MessageDlg('   ' + Name,
        mtError, [mbOk], 0);   Exit;
  end;
  //
  N := 0;
  repeat
    Readln(F1, NewCod);
    Str[N] := NewCod;
    if N > 118 then
    begin  CloseFile(F1);
           Exit;
    end
    else inc(N);
  until Eof(F1);
  //
  Nmr := N;
  CloseFile(F1);
end; {FileRead}

procedure TSDIAppForm.FileWrite(Name: String);
var
  F2: TextFile;
  //NewCod: String;
  N : integer;
begin
  AssignFile(F2, Name);
  Rewrite(F2);
  for N := 0 to (Nmr-1) do
  begin
    if Str[N] <> '' then  Writeln(F2, Str[N]);
  end;
  CloseFile(F2);
end; {FileWrite}

procedure TSDIAppForm.Roulette;
begin
  Panel3.Caption := Str[ Random(Nmr) ];
  Panel4.Caption := Str[ Random(Nmr) ];
  Panel5.Caption := Str[ Random(Nmr) ];
  Panel6.Caption := Str[ Random(Nmr) ];
  //
  NPrize := Random(Nmr);
  Panel7.Caption := Str[ NPrize ];
  //
  Panel8.Caption := Str[ Random(Nmr) ];
  Panel9.Caption := Str[ Random(Nmr) ];
  Panel10.Caption := Str[ Random(Nmr) ];
  Panel11.Caption := Str[ Random(Nmr) ];
end;

procedure TSDIAppForm.BitBtn1Click(Sender: TObject);
begin
  Randomize;
  Roulette;
  //
  Timer2.Enabled := False;
  Timer3.Enabled := False;
  Panel7.Color := clBtnFace;
    MediaPlayer1.Stop;
    MediaPlayer1.Close;
    MediaPlayer1.FileName := 'sound9.wav'; //*****
    MediaPlayer1.Open;
    MediaPlayer1.Play;
  //
  Gauge1.Progress := Gauge1.MinValue;
  Timer1.Enabled  := True;
  Timer2.Interval := 300;
  Timer3.Interval := 500;
  Timer3.Enabled  := True;
  Panel7.Color := clBtnFace;
end;

procedure TSDIAppForm.Timer1Timer(Sender: TObject);
begin // -
  if Gauge1.Progress = 26 then Timer3.Interval := 400;
  if Gauge1.Progress = 38 then Timer3.Interval := 300;
  if Gauge1.Progress = 52 then Timer3.Interval := 200;
  if Gauge1.Progress = 62 then Timer3.Interval := 150;
  if Gauge1.Progress = 76 then Timer3.Interval := 100;
  //
  if Gauge1.Progress = Gauge1.MaxValue then
  begin
    Timer1.Enabled := False;
    Timer2.Enabled := True;   T2N := 0;
      MediaPlayer1.Stop;
      //MediaPlayer1.Close;
      MediaPlayer1.FileName := 'sound6.wav'; //*****
      MediaPlayer1.Open;
      MediaPlayer1.Play;
    Timer3.Enabled := False;
  end
  else
  begin
    Gauge1.Progress := Gauge1.Progress + 1;
  end;
end;

procedure TSDIAppForm.BitBtn2Click(Sender: TObject);
begin
  Timer1.Enabled := False;
  Timer2.Enabled := False;
  Timer3.Enabled := False;
  //
  MediaPlayer1.Stop;
  MediaPlayer1.FileName := 'sound4.wav'; //*****
  MediaPlayer1.Open;
  MediaPlayer1.Play;
end;

procedure TSDIAppForm.Timer2Timer(Sender: TObject);
begin //      
  inc(T2N);
  case T2N of
    1: begin
         Panel3.Caption := '';
         //MediaPlayer1.Play;
       end;
    2: begin
         Panel4.Caption := '';
         //MediaPlayer1.Play;
       end;
    3: begin
         Panel5.Caption := '';
         //MediaPlayer1.Play;
       end;
    4: begin
         Panel6.Caption := '';
         //MediaPlayer1.Play;
       end;
    5: begin
         Panel8.Caption := '';
         //MediaPlayer1.Play;
       end;
    6: begin
         Panel9.Caption := '';
         //MediaPlayer1.Play;
       end;
    7: begin
         Panel10.Caption := '';
         //MediaPlayer1.Play;
       end;
    8: begin
         Panel11.Caption := '';
         //MediaPlayer1.Play;
         Timer2.Interval := 1000;
       end;
    9: begin
         Panel7.Color := clWhite;
         Timer2.Interval := 150;
       //MediaPlayer1.Close;
       MediaPlayer1.FileName := 'sound3.wav'; //*****
       MediaPlayer1.Open;
       end;
    10: begin Panel7.Color := clYellow;  MediaPlayer1.Play; end;
    11: begin Panel7.Color := clRed;     MediaPlayer1.Play; end;
    12: begin Panel7.Color := clWhite;   MediaPlayer1.Play; end;
    13: begin Panel7.Color := clBtnFace; MediaPlayer1.Play; end;
    14: begin Panel7.Color := clYellow;  MediaPlayer1.Play; end;
    15: begin Panel7.Color := clWhite;   MediaPlayer1.Play; end;
    16: begin Panel7.Color := clRed;     MediaPlayer1.Play; end;
    17: begin Panel7.Color := clYellow;  MediaPlayer1.Play; end;
    18: begin Panel7.Color := clLime;    MediaPlayer1.Play; end;
    19: begin
          Timer2.Enabled := False;
          Str[NPrize] := '';
{       MediaPlayer1.FileName := 'sound7.wav'; //*****
       MediaPlayer1.Open;
       MediaPlayer1.Play;}
          FileWrite('2.txt');
          FileRead( '2.txt');
       MediaPlayer1.FileName := 'sound8.wav'; //*****
       MediaPlayer1.Open;
       MediaPlayer1.Play;
        end;
  end;
end;

procedure TSDIAppForm.Timer3Timer(Sender: TObject);
begin //  
  Roulette;
end;

procedure TSDIAppForm.SpeedButton1Click(Sender: TObject);
begin
  FormActivate(Sender);
end;

procedure TSDIAppForm.SpeedButton2Click(Sender: TObject);
begin
  Panel3.Caption := '';
  Panel4.Caption := '';
  Panel5.Caption := '';
  Panel6.Caption := '';
  Panel7.Caption := '';
  Panel8.Caption := '';
  Panel9.Caption := '';
  Panel10.Caption := '';
  Panel11.Caption := '';
end;

procedure TSDIAppForm.SpeedButton3Click(Sender: TObject);
begin
  Roulette;
end;

procedure TSDIAppForm.SpeedButton4Click(Sender: TObject);
begin
  FileRead( '2.txt');
end;


end.

